/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.placeholder;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import org.tinygroup.logger.Logger;
import org.tinygroup.logger.LoggerFactory;


/**
 * main函数运行类
 * 
 * @author renhui
 * 
 */
public class PlaceholderMainClass {

	private static Logger logger = LoggerFactory.getLogger(PlaceholderMainClass.class);
	public static void replace() {
		org.tinygroup.placeholder.PlaceholderMainClass.main(new String[]{});
	}
	
	
	/**
	 * -processorFolder=c:\asfasdf,d:\aasdf\wwa.war -fileSuffix=text,xml,html
	 * -placeholderProperties
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		
		Properties properties = new Properties();
		String source = null;
		String fileSuffix = null;
		String placeholderProperties = null;
		InputStream stream = null;
		if (args.length == 3) {
			// read arguments...
			StringBuffer buffer = new StringBuffer();
			buffer.append(args[0]).append("\n").append(args[1]).append("\n")
					.append(args[2]);
			stream = new ByteArrayInputStream(buffer.toString().getBytes());
		} else {
			stream = Thread.currentThread().getContextClassLoader()
					.getResourceAsStream("PlaceholderConfig.properties");
		}
		try {
			properties.load(stream);
		} catch (IOException e) {
			logger.errorMessage("加载PlaceholderConfig.properties时出错", e);
		} finally {
			try {
				stream.close();
			} catch (IOException e) {
				logger.errorMessage("关闭流出错", e);
			}
		}
		source = properties.getProperty("processorFolder");
		fileSuffix = properties.getProperty("fileSuffix");
		placeholderProperties = properties.getProperty("placeholderProperties");
		// 开始占位符替换工作
		MainLoad load = new MainLoad();
		load.startResolver(source, fileSuffix, placeholderProperties);

	}

}
